#pragma once
#include <easy2d/e2dmacros.h>
#include <easy2d/e2dcommon.h>

namespace easy2d
{

class Game;
class Input;
class Renderer;
class Node;
class Scene;
class Timer;
class Action;
class Transition;


// 
class SceneManager
{
	friend class Game;
	friend class Renderer;

public:
	// л
	static void enter(
		Scene * scene,						/* һָ */
		Transition * transition = nullptr,	/* л */
		bool saveCurrentScene = true		/* Ƿ񱣴浱ǰ */
	);

	// һ
	static void back(
		Transition * transition = nullptr	/* л */
	);

	// ձг
	static void clear();

	// ȡǰ
	static Scene * getCurrentScene();

	// ȡջ
	static std::stack<Scene*> getSceneStack();

	// Ƿڽת
	static bool isTransitioning();

	// ַ¼
	static void dispatch(Event* evt);

private:
	// ³
	static void __update();

	// Ⱦ
	static void __render();

	// ʼ
	static bool __init();

	// ճԴ
	static void __uninit();
};


// 
class ActionManager
{
	friend class Game;
	friend class Node;
	friend class Action;

public:
	// ִж
	static void start(
		Action * action,
		Node * target,
		bool paused
	);

	// ͬж
	static void resume(
		const String& name
	);

	// ͣͬж
	static void pause(
		const String& name
	);

	// ֹͣͬж
	static void stop(
		const String& name
	);

	// ȡͬĶ
	static std::vector<Action *> get(
		const String& name
	);

	// ȡж
	static const std::vector<Action*>& getAll();

private:
	// ¶״̬
	static void __update();

	// ڽڵϵж
	static void __resumeAllBindedWith(
		Node * target
	);

	// ͣڽڵϵж
	static void __pauseAllBindedWith(
		Node * target
	);

	// ֹͣڽڵϵж
	static void __stopAllBindedWith(
		Node * target
	);

	// հڽڵϵж
	static void __clearAllBindedWith(
		Node * target
	);

	// ж״̬
	static void __resetAll();

	// Դ
	static void __uninit();
};


}